<template>
  <single-pane >

    <template v-slot:header>
      <BasePricesFilterPanel :type="type" @change="onChangeFilterData" />
    </template>
    <BasePricesTable ref="pricesTable" v-show="filterData.viewMode === 'locations'" />

    <ClusterBasePricesTable :filter-data="filterData" ref="clusterPricesTable" v-show="filterData.viewMode !== 'locations'" />

    <ob-modal
      ref="planner"
      size="small"
      title="Планировщик перерасчета базовой цены"
      :is-show-controls="true"
      ok-text="Сохранить"
      @submit="$emit('on-submit')"
    >
      <planner-modal />
    </ob-modal>

  </single-pane>
</template>

<script>
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObModal from 'common-components/src/obComponents/obModal';

import PlannerModal from './components/PlannerModal';
import BasePricesFilterPanel from './components/FuncPanel/filterPanel';
import BasePricesTable from './components/BasePriceTable';
import ClusterBasePricesTable from './components/ClusterBasePriceTable';

export default {
  name: 'BasePrices',
  components: {
    SinglePane,
    ObModal,
    BasePricesFilterPanel,
    PlannerModal,
    BasePricesTable,
    ClusterBasePricesTable,
  },
  data() {
    return {
      type: this.$route.query.type || 'LOCATION',
      filterData: {},
    };
  },
  computed: {
  },
  watch: {
    type: {
      handler() {
        if (this.$route.query.type !== this.type)
          this.$router.replace({ query: { type: this.type } })
      },
      deep: true,
      immediate: true
    }
  },
  methods: {
    ...mapActions({
      getServices: 'base_prices/getServices',
    }),
    onChangeFilterData( filterData ) {
      this.filterData = filterData;
      this.type = filterData.type;
      if( filterData.type === 'LOCATION' ){
        if(filterData.locationFrom && filterData.locationTo) {
          this.$refs.pricesTable.updateLocations({from: filterData.locationFrom, to: filterData.locationTo});
        } else {
          this.$refs.pricesTable.clearTable();
        }
      }
    },
    openMathModal() {
      this.$refs.settings.openMathModal();
    },
  },
  async mounted() {
    this.getServices();
  },
};
</script>

<style lang="scss" scoped>
$cobalt-blue: #0242ad;
$cobalt: #004bc8;

@import '~common-components/src/static/css/mixins';

.page-controls {
  position: absolute;
  right: 0;
  margin: -40px 35px 0 20px;
  display: flex;
  align-items: center;
  button {
    @include font-mixin(12px, 16px, 500, $cobalt, 1.6px);
    text-transform: uppercase;
  }
}

.mb20 {
  margin-bottom: 20px;
}
.mb40 {
  margin-bottom: 40px;
}
</style>
